#!/usr/bin/python
# Copyright 2001,2003-2004 The Apache Software Foundation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by licable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

"""

 diary.py
    
    This script is based on runant.py
    
 runant.py

    This script is a translation of the runant.pl written by Steve Loughran.
    It runs ant with/out arguments, it should be quite portable (thanks to
    the python os library)
    This script has been tested with Python2.0/Win2K

 created:         2001-04-11
 author:          Pierre Dittgen pierre.dittgen@criltelecom.com

 Assumptions:

 - the "java" executable/script is on the command path
"""
import os, os.path, string, sys

# Change it to 1 to get extra debug information
debug = 1

#######################################################################

DIST_DIR = os.path.dirname(os.path.abspath(sys.argv[0]))

# set JAVACMD (check variables JAVACMD and JAVA_HOME)
JAVACMD = None
if not os.environ.has_key('JAVACMD'):
    if os.environ.has_key('JAVA_HOME'):
        if not os.path.exists(os.environ['JAVA_HOME']):
            print "Warning: JAVA_HOME is not defined correctly."
        else:
            JAVACMD = os.path.join(os.environ['JAVA_HOME'], 'bin', 'java')
    else:
        print "Warning: JAVA_HOME not set."
else:
    JAVACMD = os.environ['JAVACMD']
if not JAVACMD:
    JAVACMD = 'java'
  

#this gets patched by the build file, when we get copied to the dist directory.
target = '[[TARGET.NAME]]'

app = os.path.join(DIST_DIR, target)
if not os.path.exists(app):
    print 'Unable to locate application at %s\n' % app

# Builds the commandline
cmdline = ('%s -jar %s %s') \
     % (JAVACMD, app, string.join(sys.argv[1:], ' '))

#cmdline = ["-jar", app]+ sys.argv[1:] 
     
if debug:
    print cmdline
sys.stdout.flush()

# Run the bin!
os.system(cmdline)
#os.execv(JAVACMD, cmdline)
