package d1.core;

import java.text.ParseException;
import java.io.IOException;
import java.io.File;

/**
 
 */
public class DiaryMain {

    public DiaryMain(String filename) {
    this.filename = filename;
}

/**
 * filename
 */

private String filename;

/** our calendar */
private Events calendar= new Events();

public Event add(String time,String name,String text)
		throws ParseException {
    Event event=calendar.createEvent();
    event.setName(name);
    event.setText(text);
    event.setDate(time);
    event.validate();
    return event;
}

public boolean load(boolean mustExist)
		throws IOException {
    if(!mustExist) {
        File f=new File(filename);
        if(!f.exists()) {
            //exit: no files
            return false;
        }
    }
    Events.load(filename);
    return true;
}

public void save() throws IOException {
    calendar.save(filename);
}

public String toString() {
    return "File :"+filename+"\n"+calendar.toString();
    }

    public static void main(String args[])
            throws Exception {
        DiaryMain diaryMain = new DiaryMain("calendar.d1");
        diaryMain.load(false);
        if (args.length > 0) {
            String time = args[0];
            String name = null;
            name = args.length > 1 ? args[1] : "event";
            String text = null;
            text = args.length > 2 ? args[2] : null;
            diaryMain.add(time, name, text);
        }
        diaryMain.save();
        System.out.println(diaryMain.toString());
    }


}
