package d1.persist.hibernate;

import org.hibernate.cfg.Environment;

/**
 * This is just a set of hibernate constants. Either extend this class or
 * statically import it.
 */
public class HibernateConstants {

    /**
     * JDBC URL for the database. {@value}
     */

    public static final String HBM2DDL_AUTO = "hibernate.hbm2ddl.auto";

    /**
     * select HSQLDB for the database {@value}
     */

    public static final String DIALECT_HSQLDB = "org.hibernate.dialect.HSQLDialect";
    /** select HSQLDB for the database {@value} */

    public static final String DIALECT_HSQLDB =
        "org.hibernate.dialect.HSQLDialect";

    /**
     * HSQLDB JDBC driver classname {@value}
     */

    public static final String DRIVER_HSQLDB = "org.hsqldb.jdbcDriver";

    /**
     * select MySQL for the database {@value}
     */

    public static final String DIALECT_MYSQL = "org.hibernate.dialect.MySQLDialect";

    /**
     * MySQL JDBC driver classname {@value}
     */

    public static final String DRIVER_MYSQL = "com.mysql.jdbc.Driver";

    /**
     * JDBC URL For an HSQLDB in-memory database {@value}
     */
    public static final String HSQL_MEMORY_DATABASE = "jdbc:hsqldb:mem:.";

    /**
     * DDL command to create the db schema and drop it when the factory is
     * closed {@value}
     */
    public static final String DDL_CREATE_DROP = "create-drop";

    /**
     * DDL command to create the db schema when the db is created {@value}
     */
    public static final String DDL_CREATE = "create";

    /**
     * DDL command {@value}
     */
    public static final String DDL_VALIDATE = "validate";

}
