package d1.persist.test.hibernate;

import junit.framework.Assert;

import java.io.InputStream;

/**
 * Test that our configuration is itself valid
 */
public class ConfigurationTest extends HibernateTestBase {

    public ConfigurationTest(String s) {
        super(s);
    }

    /**
     * try and load persistence.xml
     *
     * @throws Exception
     */
    public void testPersistXml() throws Exception {
        InputStream stream = this.getClass()
                .getClassLoader()
                .getResourceAsStream("META-INF/persistence.xml");
        Assert.assertNotNull("missing META-INF/persistence.xml", stream);
        stream.close();
    }

    /**
     * If this test fails, then there the provider is missing, and all entity
     * manager tests are gone.
     *
     * @throws Exception
     */
    public void testHibernateEntityManagerOnClasspath() throws Exception {
        Class entityManagerClass =Class.forName(
                        "org.hibernate.ejb.HibernatePersistence");
        Object persistenceProvider = entityManagerClass.newInstance();
    }

    public void testHsqldbOnClasspath() throws Exception {
        Class clazz = Class.forName(
                "org.hsqldb.jdbcDriver");
        Object instance = clazz.newInstance();
    }

}
