package d1.webapp.servlets;

import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.io.FeedException;
import com.sun.syndication.io.SyndFeedOutput;
import d1.persist.session.CalendarSession;
import d1.webapp.EventSyndicator;
import d1.webapp.config.JBoss4Calendar;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

/*
 * This servlet feeds out events as an Atom feed
*/

/**
 * @web.servlet name="EventFeed" display-name="EventFeed"
 * @web.servlet-mapping url-pattern="/feed/"
 */
public class EventFeedServlet extends HttpServlet {


    /**
     * process a GET request
     */
    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
            throws ServletException, IOException {
        EventSyndicator syndicator = createFeed(request);
        try {
            SyndFeed feed = syndicator.getFeed();
            feed.setFeedType("atom_1.0");
            response.setContentType("application/xml");
            SyndFeedOutput output = new SyndFeedOutput();
            output.output(feed, response.getWriter());
        }
        catch (FeedException e) {
            //wrap and throw; let the stack handle it.
            ServletException se =
                    new ServletException("When creating feed", e);
            throw se;
        }
    }

    private EventSyndicator createFeed(HttpServletRequest request) {
        String base = extractApplicationURL(request);
        CalendarSession session = JBoss4Calendar.getSession();
        EventSyndicator feed;
        feed = new EventSyndicator("Events",
                base,
                session.getEvents());
        return feed;
    }

    /**
     * Extract the URL from the servlet request, to use in future requests.
     *
     * @param request
     * @return the base URL of the application
     */
    private String extractApplicationURL(HttpServletRequest request) {
        String host;
        String protocol;
        int port;
        try {
            URL url;
            url = new URL(request.getRequestURL().toString());
            host=url.getHost();
            protocol=url.getProtocol();
            port=url.getPort();
        } catch (MalformedURLException e) {
            host="localhost";
            port=8080;
            protocol="http";
        }
        String newURL=protocol+"://"+host+":"+port+"/diary/";
        return newURL;
    }

}
