package d1.webapp.servlets;

import d1.persist.PersistTools;
import d1.persist.session.CalendarCreator;
import d1.webapp.config.CalendarBinding;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import java.util.Properties;

/**
 * Gets called very on in the lifecycle to initialise the database bindings
 * for everyone
 * @web.listener
 */
public class LifecycleListener implements ServletContextListener {

    public void contextInitialized(ServletContextEvent servletContextEvent) {

        //get the JVM properties and act off them, if set
        Properties sysProps=System.getProperties();
        Properties actualProps=PersistTools.extractOptionsWithPrefix(sysProps,CalendarBinding.BINDING_PREFIX);
        CalendarBinding.configureCalendar(actualProps);
    }


    /**
     * On shutdown, we close the calendar session.
     * @param servletContextEvent the lifecycle event
     */
    public void contextDestroyed(ServletContextEvent servletContextEvent) {
        CalendarCreator.close();
    }
}
