package d1.webapp.test;

import com.meterware.httpunit.WebResponse;

import java.io.IOException;

import org.xml.sax.SAXException;

/**
 * Test all the diagnostics JSP pages.
 * This isnt covered in the book, but rounds off the coverage
 */
public class DiagnosticsTest extends WebTestBase{


    public DiagnosticsTest(String name) {
        super(name);
    }

    /**
     * get a diags page
     * @param name jsp page name
     * @return the response
     * @throws IOException io trouble
     * @throws SAXException failure to parse the page
     */
    private WebResponse getDiagnosticsPage(String name)
        throws IOException, SAXException {
        return getPage("/diagnostics/"+name);
    }

    public void testDiaryDS() throws Throwable {
        getDiagnosticsPage("diaryds.jsp");
    }

    public void testDefaultDS() throws Throwable {
        getDiagnosticsPage("defaultds.jsp");
    }

    public void testCalendarBean() throws Throwable {
        getDiagnosticsPage("calendarbean.jsp");
    }

    public void testCalendar2() throws Throwable {
        getDiagnosticsPage("calendar2.jsp");
    }

    public void testListRoot() throws Throwable {
        getDiagnosticsPage("list.jsp");
    }

    public void testToStringRoot() throws Throwable {
        getDiagnosticsPage("tostring.jsp?path=/");
    }

    public void testListJava() throws Throwable {
        getDiagnosticsPage("list.jsp?path=java:");
    }

    public void testToStringJava() throws Throwable {
        getDiagnosticsPage("tostring.jsp?path=java:");
    }

}
