package d1.webapp.test.cactus;

import d1.persist.Event;
import d1.persist.session.CalendarSession;
import d1.webapp.config.JBoss4Calendar;
import org.apache.cactus.ServletTestCase;

import java.util.Date;
import java.util.UUID;

/**
 * This is the test case in chapter14
 */
public class CalendarSessionTest extends ServletTestCase {
    private CalendarSession calendar;

    public CalendarSessionTest(String string) {
        super(string);
    }

    /**
     * Sets up the fixture, for example, open a network connection. This method
     * is called before a test is executed.
     */
    protected void setUp() throws Exception {
        super.setUp();
        calendar = JBoss4Calendar.getSession();
    }

    public void testAddAndRemove() throws Exception {
        Event e = new Event(UUID.randomUUID(),
                new Date(),"test","test adding");
        calendar.addOrUpdate(e);
        Event found1 = calendar.findEvent(e.getKey());
        assertEquals(e, found1);
        calendar.removeEvent(e.getKey());
        assertNull(calendar.findEvent(e.getId()));
    }

}
