package d1.webapp.test.cactus;

import org.apache.cactus.ServletTestCase;

import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;

import d1.persist.Event;

import java.util.UUID;
import java.util.Date;

/**
 * This tests entity binding.
 * It relies on the classes of EJB being on the test client path, and the
 * annotations being harmless.
 */
public class EntityBindingTest extends ServletTestCase {

    @PersistenceContext
    public EntityManager manager;

    public void testManagerInjected() throws Exception {
        assertNotNull("Persistence Context injection failed",manager);
    }

    public void testPersist() throws Exception {
        Event e = new Event(UUID.randomUUID(),
                new Date(), "test", "test adding");
        manager.persist(e);
    }
}
