package d1.webapp.test.cactus;

import org.apache.cactus.ServletTestCase;
import d1.persist.session.CalendarSession;
import d1.persist.session.JavaEECalendarFactory;
import d1.persist.Event;
import d1.webapp.config.JBoss4Calendar;

import java.util.UUID;
import java.util.Date;

/**
 * This tests that we can inject sessions.
 */
public class SessionInjectionTest extends ServletTestCase {

    public SessionInjectionTest(String string) {
        super(string);
    }

    /**
     * Sets up the fixture, for example, open a network connection. This method
     * is called before a test is executed.
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    public CalendarSession createSession() {
        JavaEECalendarFactory factory=new JavaEECalendarFactory();
        CalendarSession session = factory.getSession();
        assertNotNull("Factory is returning null sessions; injection broken?",
                        session);
        return session;
    }

    public void testSessionCreation() {
        createSession();
    }

    public void testAddAndRemove() throws Exception {
        CalendarSession calendar=createSession();
        Event e = new Event(UUID.randomUUID(),
                new Date(),"test","test adding");
        calendar.addOrUpdate(e);
        Event found1 = calendar.findEvent(e.getKey());
        assertEquals(e, found1);
        calendar.removeEvent(e.getKey());
        assertNull(calendar.findEvent(e.getId()));
    }

}
