package d1.persist.session;

import d1.persist.Event;

import java.util.List;
import java.util.UUID;

/**
 */
public abstract class AbstractCalendar implements CalendarSession {


    /**
     * Find a new event
     *
     * @param id
     *
     * @return the event
     */
    public Event findEvent(UUID id) {
        return findEvent(id.toString());
    }

    /**
     * Get all events in the database
     *
     * @return all events
     */
    public List<Event> getEvents() {
        return getEvents(null);
    }

    /**
     * Build a select string from a query term.
     *
     * @param where the select string
     * @return the query string
     */
    protected String makeSelection(String where) {
        String queryString = "FROM Event event ";
        if (where != null && where.length() > 0) {
            queryString = queryString + " WHERE " + where;
        }
        return queryString;
    }

    /**
     * Get the number of events in the database
     *
     * @return the current event count
     */
    public int getEventCount() {
        return getEventCount(null);
    }
}
