package d1.persist.session;


/**
 */
public interface CalendarFactory {

    /**
     * Return a new or existing calendar session.
     * @return a calendar session.
     */
    CalendarSession getSession();

    /**
     * Close the factory. Called at the end of life of the system, though
     * this cannot be guaranteed.
     */
    void closeFactory();


    /**
     * Get the likely cause of failure.
     * @return details to include in error messages.
     */
    String getLikelyCauseOfFailure();
}
