package d1.persist.session;

import javax.ejb.EJB;

/**
 * This class is a factory for application calendars, that binds using
 * dependency injection
 *
 */
public class JavaEECalendarFactory implements CalendarFactory {


    @EJB(name = "CalendarSessionBean")
    private CalendarSession session=null;
    private static final String NO_BEAN_INJECTION =
        "Bean injection is not working on this application server";

    public JavaEECalendarFactory()  {
    }

    /**
     * Return a new or existing calendar session.
     *
     * @return a calendar session.
     */
    public CalendarSession getSession() {
        if(session==null) {
            throw new IllegalStateException(NO_BEAN_INJECTION);
        }
        return session;
    }

    /**
     * Close the factory. Called at the end of life of the system, though this
     * cannot be guaranteed.
     */
    public void closeFactory() {

    }


    public String getLikelyCauseOfFailure() {
        return NO_BEAN_INJECTION;
    }

    /**
     * Returns a string representation of the object.
     *
     * @return a string representation of the object.
     */
    public String toString() {
        return "JavaEECalendarFactory with session="+session;
    }
}
