package d1.persist.test;

import d1.persist.Event;
import d1.persist.PersistTools;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;

/**
 */
public abstract class Ejb3TestBase extends PersistenceTestBase {
    private EntityManagerFactory factory = null;
    protected EntityManager manager;

    protected Ejb3TestBase(String s) {
        super(s);
    }

    /**
     * Sets up the fixture, for example, open a network connection.
     * This method is called before a test is executed.
     */
    protected void setUp() throws Exception {
        super.setUp();
        if(factory==null) {
            factory = PersistTools.createEntityManagerFactory(getSettings());
        }
        openManager();
    }

    protected void openManager() {
        manager = factory.createEntityManager();
    }

    protected void closeManager() {
        if(manager!=null) {
            manager.close();
            manager=null;
        }
    }

    /**
     * Tears down the fixture, for example, close a network connection.
     * This method is called after a test is executed.
     */
    protected void tearDown() throws Exception {
        super.tearDown();
        closeManager();
    }

    protected Event createAndSaveEvent() throws Exception {
        Event event = createTestEvent();
        EntityTransaction transaction = null;
        try {
            transaction = manager.getTransaction();
            transaction.begin();
            manager.persist(event);
            transaction.commit();
            return event;
        } catch (Exception e) {
            PersistTools.rollback(transaction);
            throw e;
        }

    }
}
