
package d1.webapp;

import com.sun.syndication.feed.synd.SyndContent;
import com.sun.syndication.feed.synd.SyndContentImpl;
import com.sun.syndication.feed.synd.SyndEntry;
import com.sun.syndication.feed.synd.SyndEntryImpl;
import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.feed.synd.SyndFeedImpl;
import com.sun.syndication.io.FeedException;
import d1.core.Event;
import d1.core.Events;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;

/**
 * This class uses Rome.
 * @see <a href="https://rome.dev.java.net/">https://rome.dev.java.net/</a>
 */
public class EventSyndicator {

    private String title;

    private Events events;




    public EventSyndicator(String title, Events events) {
        this.title=title;
        this.events = events;
    }

    public SyndFeed getFeed()
            throws IOException, FeedException {
        SyndFeed feed = new SyndFeedImpl();
        feed.setTitle(title);
        feed.setUri(events.getId());
        feed.setAuthor(events.getAuthor());
        feed.setPublishedDate(new Date());
        List<SyndEntry> entries = new ArrayList<SyndEntry>();
        SyndEntry entry;
        for(Event event:events) {
            entry = new SyndEntryImpl();
            entry.setTitle(event.getName());
            entry.setUri(event.getId().toString());
            entry.setAuthor(events.getAuthor());
            SyndContent description=new SyndContentImpl();
            description.setValue(event.getText());
            description.setType("text");
            entry.setDescription(description);
            entry.setPublishedDate(event.getDate());
            entry.setUpdatedDate(event.getDate());
            entries.add(entry);
        }
        feed.setEntries(entries);
        return feed;
    }
}
