package d1.webapp;

import java.net.URL;

/** find a class */
public class FindClass {


    private FindClass() {
    }

    public static String locate(String classname) {
        return locate(classname, "failed to load " + classname);
    }

    public static String locate(String classname, String text) {
        try {
            Class type = Class.forName(classname);
            URL url = type.getProtectionDomain()
                .getCodeSource()
                .getLocation();
            return type.toString() + " from " + url.toString();
        } catch (Throwable e) {
            throw new RuntimeException(text, e);
        }
    }


}
