package d1.webapp.servlets;

import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.io.FeedException;
import com.sun.syndication.io.SyndFeedOutput;
import d1.webapp.EventSyndicator;
import d1.webapp.GroupEvents;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/*
 * This servlet feeds out events as an Atom feed
*/

/**
 * @web.servlet name="EventFeed" display-name="EventFeed"
 * @web.servlet-mapping url-pattern="/feed/"
 */
public class EventFeedServlet extends HttpServlet {


    /**
     * event syndicator used
     */
    private EventSyndicator syndicator;

    /**
     * Servlet init logic
     */
    public void init() throws ServletException {
        GroupEvents group = GroupEvents.getGroupEvents();
        syndicator = new EventSyndicator("Events", group.getEvents());

    }

    /**
     * process a GET request
     */
    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
            throws ServletException, IOException {

        try {
            SyndFeed feed = syndicator.getFeed();
            feed.setFeedType("atom_1.0");
            response.setContentType("application/xml");
            SyndFeedOutput output = new SyndFeedOutput();
            output.output(feed, response.getWriter());
        }
        catch (FeedException e) {
            //wrap and throw; let the stack handle it.
            ServletException se =
                    new ServletException("When creating feed", e);
            throw se;
        }
    }

}
