package d1.webapp.test;

import com.meterware.httpunit.HttpInternalErrorException;
import com.meterware.httpunit.WebLink;
import com.meterware.httpunit.WebRequest;
import com.meterware.httpunit.WebResponse;


/** Test the root page and happy/unhappy jsp pages */

public class HappyPageTest extends WebTestBase {

    public HappyPageTest(String name) {
        super(name);
    }

    /**
     * pull in the start page and the happy page
     *
     * @throws Exception trouble
     */
    public void testIndex() throws Throwable {
        WebResponse home = getHomePage();
        assertEquals("Diary Web Application", home.getTitle());
        WebLink link = home.getLinkWithID("happy");
        assertNotNull("Happy link missing", link);
        WebRequest nextRequest = link.getRequest();
        WebResponse status = session.getResponse(nextRequest);
    }


    /**
     * verify our unhappy page works
     *
     * @throws Throwable on failure
     */
    public void testUnhappy() throws Throwable {
        try {
            getPage("unhappy.jsp");
            fail("should have raised an exception");
        } catch (HttpInternalErrorException e) {
            //success
        }
    }

    public void testHappy() throws Throwable {
        getPage("happy.jsp");
    }
}

