
package d1.webapp.test;

import com.meterware.httpunit.HttpInternalErrorException;
import com.meterware.httpunit.WebLink;
import com.meterware.httpunit.WebRequest;
import com.meterware.httpunit.WebResponse;

/**
 * test indexing
 */
public class IndexTest extends WebTestBase {

    public IndexTest(String name) {
        super(name);
    }

    /**
     * Test all the links on the page, but ignore the ones that are deliberately
     * unhappy, which are allowed to create 500 errors
     *
     * @throws Exception if a test fails
     */
    public void testEveryLinkOnThePage() throws Exception {
        WebResponse home = getHomePage();
        WebLink[] links = home.getLinks();
        for (WebLink link : links) {
            WebRequest follow = link.getRequest();
            try {
                session.getResponse(follow);
            } catch (HttpInternalErrorException e) {
                //ignore unhappy related stuff
                if (follow.getURL().toString().contains("unhappy")) {
                    //do nothing
                } else {
                    throw e;
                }
            }
        }
    }

}
