<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  <xsl:output method="text" encoding="us-ascii"/>

  <xsl:template match="/constants">
  
package d1.webapp.generated;

import javax.xml.namespace.QName;    
import java.net.URI;
import java.net.URISyntaxException;

public class Constants {
  private Constants() { }

  protected static URI makeURI(String value) {
    try {
        return new URI(value);
    } catch (URISyntaxException e) {
        throw new RuntimeException(
         "Cannot instantiate URI to "+value,e);
    }
  }

  <xsl:apply-templates select="uri"/>
  <xsl:apply-templates select="string"/>
}
</xsl:template>


<xsl:template match="uri">
  <xsl:apply-templates select="description"/>
  public static final URI 
    URI_<xsl:value-of select="@name"/>
      = makeURI("<xsl:value-of select="@value"/>");
</xsl:template>

<xsl:template match="string">
  <xsl:apply-templates select="description"/>
  public static final String
  <xsl:value-of select="@name"/> =
   "<xsl:value-of select="@value"/>";
</xsl:template>

<xsl:template match="description">
  /**
    * <xsl:value-of select="."/>
    */
</xsl:template>

</xsl:stylesheet>
