package org.antbook.tasks.filesize;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import java.io.File;

public class FilesizeTask extends Task {

    private String property;
    private File file;

    public void setProperty(String property) {
        this.property = property;
    }

    public void setFile(File file) {
        this.file = file;
    }

    public void execute() throws BuildException {
        if(property==null) {
            throw new BuildException("No property");
        }
        if(file==null) {
            throw new BuildException("No file");
        }
        if(!file.exists()) {
            throw new BuildException("Not found: "+file);
        }
        long size = file.length();
        log("The size of "+file+" is "+size, Project.MSG_DEBUG);
        getProject().setNewProperty(property, 
                        Long.toString(size));
    }
}
