

package org.antbook.tasks.runjar;

import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Java;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.types.resources.Union;

import java.util.Iterator;

/**
 * A class that runs a java program, turning the listed resources into params 
 */
public class Runjava extends Task {
    private String classname;
    private Union resources = new Union();

    public void add(ResourceCollection rc) {
        resources.add(rc);
    }
    public void setClassname(String classname) {
        this.classname = classname;
    }

    private Path classpath;

    public void setClasspath(Path classpath) {
        this.classpath = classpath;
    }

    public void setClasspathRef(Reference refid) {
        Path cp=new Path(this.getProject());
        cp.setRefid(refid);
        setClasspath(cp);
    }

    public void addClasspath(Path classpath) {
        setClasspath(classpath);
    }




    /**
     * {@inheritDoc}
     * @throws org.apache.tools.ant.BuildException
     *          if something goes wrong with the build.
     */
    public void execute() {
        Java java=new Java();
        java.bindToOwner(this);
        java.init();
        java.setFork(true);
        java.setFailonerror(true);
        java.setClasspath(classpath);
        java.setClassname(classname);
        Iterator element = resources.iterator();
        while (element.hasNext()) {
            Resource resource = (Resource) element.next();
            java.createArg().setValue(resource.toString());
        }
        java.execute();
    }

}
