package org.antbook.tasks;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.Path;

import java.io.File;

public class SetterTask extends Task {

    private boolean failOnError = false;
    public void setFailOnError(boolean failOnError) {
        this.failOnError = failOnError;
    }
    
    
    private Hex hex;
    public void setHex(Hex hex) {
        this.hex = hex;
    }
    
    private File destDir;
    public void setDestDir(File destDir) {
        this.destDir = destDir;
    }
    
    private Path path;
    public void setPath(Path path) {
        this.path = path;
        log("path = " + path);
    }
    
    public void execute() {
        log("failOnError = " + failOnError);
        
        if (hex != null) {
            log(hex + " = " + hex.intValue());
        }
        
        if (destDir != null) {
            if (!destDir.isDirectory()) {
                throw new BuildException(destDir + " is not a valid directory");
            }
        }

    }

}
