
package org.antbook.conditions;

import org.apache.tools.ant.Task;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.condition.Condition;

import java.util.List;
import java.util.ArrayList;

public class EvalTask extends Task {
    List<Condition> conditions=new ArrayList<Condition>();
    
    public void add(Condition c) {
        conditions.add(c);
    }

    public void execute() throws BuildException {
        boolean result=true;
        for(Condition c:conditions) {
            result &=c.eval();
        }
        if(!result) {
            throw new BuildException("Conditions evaluated to false");
        }
    }
}
