package org.antbook.embed;

import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DemuxOutputStream;
import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.taskdefs.Echo;
import java.io.PrintStream;

public class Embedded {

    private Project project;

    public Embedded() {
        project = new Project();
        project.init();
        DefaultLogger logger = new DefaultLogger();
        project.addBuildListener(logger);
        logger.setOutputPrintStream(System.out);
        logger.setErrorPrintStream(System.err);
        logger.setMessageOutputLevel(Project.MSG_INFO);
        System.setOut(
          new PrintStream(new DemuxOutputStream(project, false)));
        System.setErr(
          new PrintStream(new DemuxOutputStream(project, true)));
        project.fireBuildStarted();
    }

    public boolean run() {
        System.out.println("running");
        Throwable caught=null;
        try {
            Echo echo=new Echo();
            echo.setTaskName("Echo");
            echo.setProject(project);
            echo.init();
            echo.setMessage("Hello, world");
            echo.execute();
        } catch (BuildException e) {
            caught=e;
        }
        project.log("finished");
        project.fireBuildFinished(caught);
        //return success flag
        return caught==null;
    }

    public static void main(String args[]) {
        Embedded embed=new Embedded();
        embed.run();
    }
}
