

package org.antbook.listeners;

import org.apache.tools.ant.BuildListener;
import org.apache.tools.ant.BuildEvent;

/** a listener that collects statistics and then prints them when builds finish */
public class StatsListener implements BuildListener {

    private Tracker builds = new Tracker("Builds");
    private Tracker targets = new Tracker("Targets");
    private Tracker tasks = new Tracker("Tasks");

    public void buildStarted(BuildEvent event) {
        builds.enter(event);
    }

    public void buildFinished(BuildEvent event) {
        builds.exit(event);
        System.out.println(builds);
        System.out.println(targets);
        System.out.println(tasks);
    }

    public void targetStarted(BuildEvent event) {
        targets.enter(event);
    }

    public void targetFinished(BuildEvent event) {
        targets.exit(event);
    }

    public void taskStarted(BuildEvent event) {
        tasks.enter(event);
    }

    public void taskFinished(BuildEvent event) {
        tasks.exit(event);
    }

    public void messageLogged(BuildEvent event) {
        //discarded
    }

}
