package org.antbook.listeners;

import org.apache.tools.ant.BuildEvent;

public class Tracker {
    private int count;
    private int depth;
    private Throwable thrown;
    private String category;

    public Tracker(String category) {
        this.category = category;
    }

    public synchronized void enter(BuildEvent event) {
        count++;
        depth++;
    }

    public synchronized void exit(BuildEvent event) {
        depth--;
        if(event.getException()!=null) {
            //cache the last exception received
            thrown =event.getException();
        }
    }

    public String toString() {
        StringBuffer state =new StringBuffer();
        state.append(category);
        state.append("=");
        state.append(count);
        if(depth>0) {
            state.append(" depth=");
            state.append(depth);
        }
        if (thrown !=null) {
            state.append(" (failure)");
        }
        return state.toString();
    }
}
