package org.antbook.resources;

import java.io.InputStream;
import java.io.IOException;
import java.security.SecureRandom;

/**
 * An input stream that creates a random source of data
 */
class RandomInputStream extends InputStream {

    private SecureRandom generator;
    private long size;

    public RandomInputStream(SecureRandom rng, long size) {
        this.generator = rng;
        this.size = size;
    }

    public synchronized int read() throws IOException {
        if(size--<=0) {
            return -1;
        }
        return generator.nextInt(256);
    }
}
