package org.antbook.resources;

import java.io.InputStream;
import java.io.IOException;
import java.security.SecureRandom;

/**
 * An input stream that creates a random source of data
 */
class RandomInputStreamMinMax extends InputStream {

    private SecureRandom generator;
    private long size;
    private int min=0;
    private int range=256;

    public RandomInputStreamMinMax(SecureRandom rng, long size,
                                   int min,int max) {
        this.generator = rng;
        this.size = size;
        this.min=min;
        range=max-min;
    }


    public synchronized int read() throws IOException {
        if(size<=0) {
            return -1;
        }
        size--;
        return generator.nextInt(range)+min;
    }
}
